Bug 1301683 - openssl: X509_verify_cert() ignores EKU extension of trust anchors
openssl: X509_verify_cert() ignores EKU extension of trust anchors
Status: CLOSED NOTABUG
Product: Security Response
Classification: Other
Component: vulnerability (Show other bugs)
unspecified
All Linux
medium Severity medium
: ---
: ---
Assigned To: Red Hat Product Security
impact=moderate,public=20170324,repor...
: Security
Depends On:
Blocks: 1301692
  Show dependency treegraph
 
Reported: 2016-01-25 11:52 EST by Adam Mariš
Modified: 2017-03-24 02:45 EDT (History)
24 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2017-03-24 02:45:46 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Proposed patch from upstream (1.82 KB, patch)
2016-02-15 11:20 EST, Adam Mariš
no flags Details | Diff
Proposed patch from upstream (1.84 KB, patch)
2016-02-15 11:21 EST, Adam Mariš
no flags Details | Diff
Master/mitaka patch (11.24 KB, patch)
2016-02-15 11:21 EST, Adam Mariš
no flags Details | Diff
Proposed patch from upstream (6.88 KB, patch)
2016-02-15 11:25 EST, Adam Mariš
no flags Details | Diff

  None (edit)
Description Adam Mariš 2016-01-25 11:52:53 EST
It was reported that X509_verify_cert() ignores the extended key usage extension of trust anchors. Only EKU extensions of intermediate and leaf certs are checked.
Comment 2 Adam Mariš 2016-01-25 12:24:37 EST
Acknowledgments:

This issue was discovered by Christian Heimes of Red Hat.
Comment 3 Adam Mariš 2016-01-27 04:50:07 EST
Quoting maintainer:

"This is a known behaviour, that is already planned to be addressed
in OpenSSL 1.1.0. In fact the EKU is only checked for certificates
from the peer, and not those from the trust store, so if your CAfile
or CApath contains intermediate certificates that get used to build
the chain, those won't be checked either."
Comment 4 Adam Mariš 2016-02-15 11:20 EST
Created attachment 1127327 [details]
Proposed patch from upstream
Comment 5 Adam Mariš 2016-02-15 11:21 EST
Created attachment 1127328 [details]
Proposed patch from upstream
Comment 6 Adam Mariš 2016-02-15 11:21 EST
Created attachment 1127329 [details]
Master/mitaka patch

Proposed patch from upstream
//ignore "master/mitaka" name
Comment 7 Adam Mariš 2016-02-15 11:25 EST
Created attachment 1127330 [details]
Proposed patch from upstream
Comment 9 Huzaifa S. Sidhpurwala 2017-03-24 02:34:28 EDT
This patch was applied to upstream master branch to fix this issue:

https://github.com/openssl/openssl/commit/33cc5dde478ba5ad79f8fd4acd8737f0e60e236e

Note You need to log in before you can comment on or make changes to this bug.